// This class was created by JaTiTV.

package net.t2code.t2codelib.VELOCITY.api.pluginMessaging;

import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteStreams;
import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.connection.PluginMessageEvent;
import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.ProxyServer;
import com.velocitypowered.api.proxy.ServerConnection;
import net.kyori.adventure.text.Component;
import net.t2code.t2codelib.util.T2C_Util;
import net.t2code.t2codelib.VELOCITY.api.commands.T2CV_Cmd;
import net.t2code.t2codelib.VELOCITY.system.T2CV_Main;
import org.slf4j.Logger;

public class T2CV_PluginMessageProxyCommand {

    private final ProxyServer server;
    private final Logger logger;


    public T2CV_PluginMessageProxyCommand(ProxyServer server, Logger logger) {
        this.server = server;
        this.logger = logger;
        server.getChannelRegistrar().register(T2CV_Main.bcmd);
    }

    @Subscribe
    public void onPluginMessageFromPlayer(PluginMessageEvent event) {
        if (event.getIdentifier() != T2CV_Main.bcmd) {
            return;
        }

        if (!(event.getSource() instanceof ServerConnection)) {
            T2CV_Main.getLogger().info(T2C_Util.getPrefix() +" [Security] §cBlocked unauthorized plugin message from a player ({})!", event.getSource().toString());
            return;
        }

        ByteArrayDataInput stream = ByteStreams.newDataInput(event.getData());
        String channel = stream.readUTF();
        String input = stream.readUTF();
        String serverID;
        try {
            serverID = stream.readUTF();
        } catch (Exception i) {
            serverID = "not Found";
        }

        if (channel.equals("T2Code-Console")) {
            logger.info("{} [{}] T2C BCMD Command Console: {}", T2C_Util.getVPrefix(), serverID, input);
            T2CV_Cmd.Console(input);
        } else {
            Player player = server.getPlayer(channel).orElse(null);
            if (player != null) {
                logger.info("{} [{}] T2C BCMD Command {}: {}", T2C_Util.getVPrefix(), serverID, player, input);
                T2CV_Cmd.Player(player, input);
            }
        }
        event.setResult(PluginMessageEvent.ForwardResult.handled());
    }

}