// This class was created by JaTiTV.

package net.t2code.t2codelib.VELOCITY.api.pluginMessaging.autoResponse;

import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.connection.PluginMessageEvent;
import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.ProxyServer;
import com.velocitypowered.api.proxy.ServerConnection;
import net.kyori.adventure.text.Component;
import net.t2code.t2codelib.VELOCITY.api.commands.T2CV_Cmd;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CV_Send;
import net.t2code.t2codelib.VELOCITY.system.T2CV_Main;
import net.t2code.t2codelib.util.T2C_Util;
import org.slf4j.Logger;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;

public class T2CV_API_AutoResponse {
    private  final ProxyServer server;
    private  final Logger logger;

    public T2CV_API_AutoResponse(ProxyServer server, Logger logger) {
        this.server = server;
        this.logger = logger;
        server.getChannelRegistrar().register(T2CV_Main.aresp);
    }

    @Subscribe
    public void onPluginmessage(PluginMessageEvent event) {
        if (event.getIdentifier() != T2CV_Main.aresp) {
            return;
        }

        if (!(event.getSource() instanceof ServerConnection)) {
            T2CV_Main.getLogger().info(T2C_Util.getPrefix() +" [Security] §cBlocked unauthorized plugin message from a player ({})!", event.getSource().toString());
            return;
        }

        DataInputStream stream = new DataInputStream(new ByteArrayInputStream(event.getData()));

        try {
            String channel = stream.readUTF();
            String input = stream.readUTF();

            switch (channel) {
                case "ConC":
                    logger.info("Command Console: {}", input);
                    T2CV_Cmd.Console(input);
                    break;
                case "ALLPMSG":
                    for (Player player : server.getAllPlayers()) {
                        T2CV_Send.player(player, input);
                    }
                    break;
                default:
                    Player player = server.getPlayer(channel).orElse(null);
                    if (player != null) {
                        logger.info("Command Console: {}", input);
                        T2CV_Cmd.Player(player, input);
                    }
                    break;
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}
